/*-
 * Copyright (C) @BABOLO  2008 Feb 11
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2008 Feb 11\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: style_0.c,v 1.11 2009/05/06 16:16:06 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <mife.h>
#include <babolo/BLINflag.h>
#include "pgoblin.h"

static int
pgoblin_finit(pgoblin_styles *this) {
    return(0);
}

static int
pgoblin_style_parse(pgoblin_styreg *reg_style, u_char *in) {
    return(EX_OK);
}

static void
pgoblin_style_dump(pgoblin_styreg *reg_style) {
    return;
}

static int
pgoblin_style_free(pgoblin_styreg *reg_style) {
    return(EX_OK);
}

static char *
pgoblin_style_get(pgoblin_styreg *reg_style, u_char *stringname) {
    char *e;

    if  (!(e = strdup(""))) errno = ENOMEM;
    return(e);
}

static int
sout(pgoblin_io *reg_out, char *c, int l) {
    int ex = 0;

    if  (c) {
        if  (!l) l = strlen(c);
        ex = reg_out->wri(reg_out->onu, c, l);
    }
    return(ex);
}

static int
pgoblin_style_tbl( pgoblin_io    *reg_out
                 , pgoblin_styreg*reg_style
                 , pgoblin_io    *reg_in
                 , ssize_t        low
                 , ssize_t        hig
                 ) {
    int ex = 0;
    ssize_t i = 0, m, w, j, l = 0;
    pgoblin_dbases *db;

    db = DBASE(reg_in->flagc);
    m = i + db->ntuples(reg_in->pq);
    w = db->nfields(reg_in->pq);
    for (; (ex >= 0) && (i < m); i++) {
        for (j = 0; (ex >= 0) && (j < w); j++) {
            if  (!db->getisnull(reg_in->pq, i, j))
                ex = sout(reg_out, db->getvalue(reg_in->pq, i, j), db->getlength(reg_in->pq, i, j));
                l += ex;
        }
    }
    return((ex < 0) ? ex : l);
}

pgoblin_styles pgoblin_style_0 =
{ "5pGoblin-" VERS
, "0\0" VERS
, pgoblin_finit
, pgoblin_finit
, pgoblin_style_parse
, pgoblin_style_dump
, pgoblin_style_free
, pgoblin_style_get
, pgoblin_style_tbl
};
